/* Tic-Tac-Toe */

#include <stdio.h>
#include <stdlib.h>

int Board[9];			/* the actual board */
						/* 0 => empty, 1 => X, 2 => O */
char *Marker = " XO";	/* what markers go on the board */           
int who=1; 				/* who is 1 for X, and 2 for O */

/* function prototypes */
void print_board_positions(void);
void print_board_status(void);
void print_board(char *pos);
int make_move(void);


int
main()
{
	print_board_positions();
	while (1)
	{ /* loop forever */
		print_board_status();
		if (make_move()) break;	/* we are done */
	}
	
	printf("Thanks for playing!\n");
	return (0);
}

void
print_board_positions(void)
{ /* print out the board positions */
	static char *positions = "012345678";	/* what the positions are */

	printf("Board positions are ...\n");	
	/* print board with position numbers instead of X's and O's */
	print_board(positions);	
}

void
print_board_status(void)	
{
	char str[10];	/* string for printing board status */
	int i, n;

	/* first, build a string representing current status */	
	for (i=0; i < 9; i++)
	{ /* loop through board */
		n = Board[i];			/* who is in this position */
		str[i] = Marker[n];		/* set to appropriate marker */
	}
	
	printf("Current board is:\n");
	
	/* now print this board */
	print_board(str);
}

void
print_board(char *pos)
{ /* display the board we are being passed */
	printf(" %c | %c | %c \n", pos[0], pos[1], pos[2]);
	printf("---+---+---+---\n");
	printf(" %c | %c | %c \n", pos[3], pos[4], pos[5]);
	printf("---+---+---+---\n");
	printf(" %c | %c | %c \n", pos[6], pos[7], pos[8]);
} 

int
make_move(void)
{
	char buf[BUFSIZ];
	int move;

	printf("Enter move for %c, or 'q' to quit, 'h' for help: ", Marker[who]);
	gets(buf);
	if (buf[0] == 'q') return 1;	/* done */
	if (buf[0] == 'h')
	{ /* help the user out */
		print_board_positions();
		return 0;
	}
	move = atoi(buf);
	
	/* validate user's move */
	if (move < 0 || move > 8)
	{
		printf("Move must be between 0 and 8\n");
		return 0;	/* try again */
	}
	if (Board[move] != 0)
	{ /* square not empty */
		printf("Position %d isn't available\n", move);
		return 0;
	}
	
	/* move valid = make it */
	Board[move] = who;	/* indicate this move */
	
	/* change who moves next */
	if (who == 1) who = 2;
	else who = 1;

	return 0;	/* normal return */	
}

